Ext.define('DSS.component.ConditionConfigurator', {
    extend : 'DSS.component.Base',
    height : '100%',
    layout : 'border',
    selectedElement : null,
    fEditMode:false,
    gridStore : null,
    grids : {},
    macPanel : null,
    mainGrid : null,
    lblSelectorAnzeige : null,
    oButtonNew : null,
    oButtonEdit : null,
    oButtonUp : null,
    oButtonDown : null,
    oButtonDelete : null,
    iDefaultWidth : 150,
    iDefaultHeight : 293,
    firstLevelStatesArray: [],
    secondLevelStates: [],
    order:null,
    values: {
        enabled: null, // singular value
        weekdays: null, // singularvalue
        timeframe: null, // array ....
        zoneState:null,
        systemState:null
    },
    fFeatureEnabled : {
        enabler : false,
        weekdays : false,
        timeframe : false,
        systemstate : false,
        zonestate : false
    },
    updateGridValues: function () {
        var iIndex=1;
        var selectedIndex=-1;
        if (this.fEditMode) {
        	selectedIndex=this.gridStore.indexOf(this.mainGrid.getSelectionModel().getSelection()[0]);
        }
        this.gridStore.removeAll();
        if (this.fFeatureEnabled.enabler) 
            if (this.values.enabled!=null)
                this.gridStore.add({pos:(iIndex++),condition:'enabler'});
        
        if (this.fFeatureEnabled.weekdays) 
            if (this.values.weekdays!=null)
                if (this.values.weekdays.length>0)
                    this.gridStore.add({pos:(iIndex++),condition:'weekdays'});       

        if (this.fFeatureEnabled.timeframe) 
            if (this.values.timeframe!=null)
                for (var jIndex=0;jIndex<this.values.timeframe.length;jIndex++)   
                    this.gridStore.add({pos:(iIndex++),condition:'timeframe',subIndex:jIndex});       

        if ((this.fFeatureEnabled.systemState)|| (this.firstLevelStatesArray.length>0)) 
            if (this.values.systemState!=null) {
                for (var jIndex=0;jIndex<this.values.systemState.length;jIndex++)   
                    this.gridStore.add({pos:(iIndex++),condition:'systemstate',subIndex:jIndex});
            }
        if (this.fFeatureEnabled.zonestate)
            if (this.values.zoneState!=null) {
                for (var jIndex=0;jIndex<this.values.zoneState.length;jIndex++)   
                    this.gridStore.add({pos:(iIndex++),condition:'zonestate',subIndex:jIndex});
            }
        if ((this.oActualValue!=null) && (!this.fEditMode))
        	this.gridStore.add({pos:(iIndex++),condition:this.oActualValue.type,subIndex:-1});
        if (selectedIndex!=-1)
        	this.mainGrid.getSelectionModel().select(selectedIndex);
        this.updatePanelDescription();
    },    
    updatePanelDescription : function() {
        if (this.oActualValue == null) {
            this.macPanel.setTitle(_('edit condition: ') + _('incomplete condition'));
        } else {
            switch (this.oActualValue.type) {
	            case 'enable':
	            	if (this.oActualValue.value!=null)
	            		this.macPanel.setTitle(_('edit condition: ') + _('Enabled'));
	            	else
	            		this.macPanel.setTitle(_('edit condition: ')  + _('incomplete condition') + ' - ' +('Enabled'));
	            	break;
	            case 'timeframe':
	            	if (this.oActualValue.value==null) 
	            		this.macPanel.setTitle(_('edit condition: ')  + _('incomplete condition') + ' - ' +  ('Timeframe'));
	            	else
	            		this.macPanel.setTitle(_('edit condition: ') + _('Timeframe'));
	            	break; 
	            case 'weekdays':
	            	if (this.oActualValue.value==null)
	            		this.macPanel.setTitle(_('edit condition: ')  + _('incomplete condition') + ' - ' + ('Weekdays'));
	            	else
	            		this.macPanel.setTitle(_('edit condition: ') + _('Weekdays'));
	            	break;
	            case 'systemState':
	            	this.macPanel.setTitle(_('edit condition: ')  + _('incomplete condition') + ' - ' + ('SystemState'));
	            	if (this.oActualValue.name!=null)
		            	this.macPanel.setTitle(_('edit condition: ')  + _('incomplete condition') + ' - ' + _(this.oActualValue.name));
	            	if (this.oActualValue.value!=null)
		            	this.macPanel.setTitle(_('edit condition: ') + _(this.oActualValue.name));
		            break;
	            case 'zoneState':
	            	this.macPanel.setTitle(_('edit condition: ')  + _('incomplete condition') + ' - ' + ('ZoneState'));
	            	if (this.oActualValue.value!=null)
		            	if (this.oActualValue.value.zone!=null)
		                	if (this.oActualValue.value.group!=null)
		                    	if (this.oActualValue.value.scene!=null)
		                    		this.macPanel.setTitle(_('edit condition: ') + _('ZoneState'));
	            	break;
	            default:
	            	this.macPanel.setTitle(_('edit condition: ') + _('incomplete condition'));
	            break;
	        }
        }
    },
    defMainGridRenderer : function(val, metadata, record, colIdx, store, view) {
        var me=this.parent;
        var oAction = record.get('condition');
        var subIndex = record.get('subIndex');
        var oDataObject=null;
        if (subIndex!=null) 
        	if (subIndex==-1) {
        		if (me.oActualValue.value!=null)
        			oDataObject=me.oActualValue.value;
        		else
        			return  _('incomplete condition');
        	}

        switch (oAction) {
            case 'timeframe': 
            	var oTimeObjectStart;
            	var oTimeObjectEnd;
            	if (oDataObject!=null) {
            		oTimeObjectStart=oDataObject.start;
            		oTimeObjectEnd=oDataObject.end;
            	}
            	else {
            		oTimeObjectStart =me.values.timeframe[record.get('subIndex')].start;
                	oTimeObjectEnd=me.values.timeframe[record.get('subIndex')].end;
            	}
                var pad = function(i) { return (i < 10 ? '0'+i : i); };
                
                var sStart="";
                if (oTimeObjectStart.timeBase=="daily") {
                    var sStart= pad(Math.floor(Math.abs(oTimeObjectStart.offset/3600))) + ":" +
                                pad(Math.floor(Math.abs(oTimeObjectStart.offset/60)%60)) + " " + _("o'clock");
                    if (oTimeObjectStart.random!=null) {
                        sStart="&plusmn;" + sText;
                    } 
                } else {
                    
                    var sStart= pad(Math.floor(Math.abs(oTimeObjectStart.offset/3600))) + ":" +
                                pad(Math.floor(Math.abs(oTimeObjectStart.offset/60)%60));

                    switch (oTimeObjectStart.timeBase)
                    {
                        case 'sunset':
                            if (oTimeObjectStart.offset==0)
                                sStart = _('at sunset');
                            else if (oTimeObjectStart.offset<0)
                                sStart = Ext.String.format2(_("{time} before sunset"),{time:sText});
                            else
                                sStart = Ext.String.format2(_("{time} after sunset"),{time:sText});
                        break;
                        case 'sunrise':
                            if (oTimeObjectStart.offset==0)
                                sStart = _('at sunrise');
                            else if (oTimeObjectStart.offset<0)
                                sStart = Ext.String.format2(_("{time} before sunrise"),{time:sText});
                            else
                                sStart = Ext.String.format2(_("{time} after sunrise"),{time:sText});
                        break;
                        case 'dawn':
                            if (oTimeObjectStart.offset==0)
                                sStart = _('at dawn');
                            else if (oTimeObjectStart.offset<0)
                                sStart = Ext.String.format2(_("{time} before dawn"),{time:sText});
                            else
                                sStart = Ext.String.format2(_("{time} after dawn"),{time:sText});
                        break;
                        case 'dusk':
                            if (oTimeObjectStart.offset==0)
                                sStart = _('at dusk');
                            else if (oTimeObjectStart.offset<0)
                                sStart = Ext.String.format2(_("{time} before dusk"),{time:sText});
                            else
                                sStart = Ext.String.format2(_("{time} after dusk"),{time:sText});
                         break;
                    }
                    if (oTimeObjectStart.limitBefore!=null)  {
        
                    	sStart+=Ext.String.format2(_("<br>but not past {hour}:{minute} o'clock"),{hour:pad(Math.floor(Math.abs(oTimeObjectStart.limitBefore/3600))),minute:pad(Math.floor(Math.abs(oTimeObjectStart.limitBefore/60)%60))});
                    }
                    if (oTimeObjectStart.limitAfter!=null)  {
                        sStart+=Ext.String.format2(_("<br>but not before {hour}:{minute} o'clock"),{hour:pad(Math.floor(Math.abs(oTimeObjectStart.limitAfter/3600))),minute:pad(Math.floor(Math.abs(oTimeObjectStart.limitAfter/60)%60))});
                    }
                    if (oTimeObjectStart.random!=null) {
                        sStart="&plusmn;" + sText;
                    } 
                }
                
                var sEnd="";
                if (oTimeObjectEnd.timeBase=="daily") {
                    var sEnd=  pad(Math.floor(Math.abs(oTimeObjectEnd.offset/3600))) + ":" +
                                pad(Math.floor(Math.abs(oTimeObjectEnd.offset/60)%60)) + " " + _("o'clock");
                    if (oTimeObjectEnd.random!=null) {
                        sEnd="&plusmn;" + sText;
                    } 
                } else {
                    
                    var sEnd=  pad(Math.floor(Math.abs(oTimeObjectEnd.offset/3600))) + ":" +
                                pad(Math.floor(Math.abs(oTimeObjectEnd.offset/60)%60));

                    switch (oTimeObjectEnd.timeBase)
                    {
                        case 'sunset':
                            if (oTimeObjectEnd.offset==0)
                                sEnd = _('at sunset');
                            else if (oTimeObjectEnd.offset<0)
                                sEnd = Ext.String.format2(_("{time} before sunset"),{time:sText});
                            else
                                sEnd = Ext.String.format2(_("{time} after sunset"),{time:sText});
                        break;
                        case 'sunrise':
                            if (oTimeObjectEnd.offset==0)
                                sEnd = _('at sunrise');
                            else if (oTimeObjectEnd.offset<0)
                                sEnd = Ext.String.format2(_("{time} before sunrise"),{time:sText});
                            else
                                sEnd = Ext.String.format2(_("{time} after sunrise"),{time:sText});
                        break;
                        case 'dawn':
                            if (oTimeObjectEnd.offset==0)
                                sEnd = _('at dawn');
                            else if (oTimeObjectEnd.offset<0)
                                sEnd = Ext.String.format2(_("{time} before dawn"),{time:sText});
                            else
                                sEnd = Ext.String.format2(_("{time} after dawn"),{time:sText});
                        break;
                        case 'dusk':
                            if (oTimeObjectEnd.offset==0)
                                sEnd = _('at dusk');
                            else if (oTimeObjectEnd.offset<0)
                                sEnd = Ext.String.format2(_("{time} before dusk"),{time:sText});
                            else
                                sEnd = Ext.String.format2(_("{time} after dusk"),{time:sText});
                         break;
                    }
                    if (oTimeObjectEnd.limitBefore!=null)  {
                        sEnd+=Ext.String.format2(_("<br>but not past {hour}:{minute} o'clock"),{hour:pad(Math.floor(Math.abs(oTimeObjectEnd.limitBefore/3600))),minute:pad(Math.floor(Math.abs(oTimeObjectEnd.limitBefore/60)%60))});
                    }
                    if (oTimeObjectEnd.limitAfter!=null)  {
                        sEnd+=Ext.String.format2(_("<br>but not before {hour}:{minute} o'clock"),{hour:pad(Math.floor(Math.abs(oTimeObjectEnd.limitAfter/3600))),minute:pad(Math.floor(Math.abs(oTimeObjectEnd.limitAfter/60)%60))});
                    }
                    if (oTimeObjectEnd.random!=null) {
                        sEnd="&plusmn;" + sText;
                    } 
                }

                return Ext.String.format2(_('only between {startTime} and {endTime}'),{startTime:sStart,endTime:sEnd});
                break;
            case 'zonestate':
            	var oZone;
            	if (oDataObject!=null)
            		oZone=oDataObject;
            	else
            		oZone=me.values.zoneState [record.get('subIndex')];
                var sString = '<table><tr><td style="padding-right:5px;height:16px;">' + dss.staticDataModel.getImageForScene(oZone.zone, oZone.group, oZone.scene) + "</td>";
                
                sString += '<td style="">';
    
                sString += dss.staticDataModel.getNameForScene(oZone.zone, oZone.group, oZone.scene);
                if (oZone.group != 0)
                    sString += _(' for ') + dss.staticDataModel.getNameForGroup(oZone.zone, oZone.group);
                
                if (oZone.zone != 0)
                    sString += _(' in ') + dss.staticDataModel.getNameForZone(oZone.zone);
                else
                    if (oZone.scene < 64)
                        sString += _(' in all rooms');
    
                sString += "</td></tr></table>";
                return sString;
                break;
            case 'systemstate':
                var oState;
                if (oDataObject!=null)
                	oState=oDataObject;
                else
                	oState=me.values.systemState[record.get('subIndex')];
                return _('grid_'+oState.name + '_' + oState.value);
                break;
            case 'enabler':
            	if (oDataObject!=null) {
	                if (oDataObject)
	                    return _('entry is enabled');
	                else
	                    return _('entry is disabled');            		
            	} else {            		
	                if (me.values.enabled)
	                    return _('entry is enabled');
	                else
	                    return _('entry is disabled');
            	}
                break;
           case 'weekdays':
               var sString = "<span>";
               
               var fMo = false;
               var fDi = false;
               var fMi = false;
               var fDo = false;
               var fFr = false;
               var fSa = false;
               var fSo = false;
               var recObject;
               if (oDataObject!=null)
            	   recObject=oDataObject;
               else
            	   recObject= me.values.weekdays;
               if (recObject.length == 7)
                   return sString + _("daily") + "</span>";
               for ( var iIndex = 0; iIndex < recObject.length; iIndex++) {
                   if (recObject[iIndex] == 'MO')
                       fMo = true;
                   if (recObject[iIndex] == 'TU')
                       fDi = true;
                   if (recObject[iIndex] == 'WE')
                       fMi = true;
                   if (recObject[iIndex] == 'TH')
                       fDo = true;
                   if (recObject[iIndex] == 'FR')
                       fFr = true;
                   if (recObject[iIndex] == 'SA')
                       fSa = true;
                   if (recObject[iIndex] == 'SU')
                       fSo = true;
               }
               if (recObject.length == 2)
                   if (fSa)
                       if (fSo)
                           return sString + _('on weekends')+'</span>';
       
               if (recObject.length == 5)
                   if (fMo)
                       if (fDi)
                           if (fMi)
                               if (fDo)
                                   if (fFr)
                                       return sString + _('MO-FR')+'</span>';
               if (recObject.length == 1) {
                   if (fMo)
                       return sString + _("on monday")+"</span>";
                   if (fDi)
                       return sString + _("on tuesday")+"</span>";
                   if (fMi)
                       return sString + _("on wednesday")+"</span>";
                   if (fDo)
                       return sString + _("on thursday")+"</span>";
                   if (fFr)
                       return sString + _("on friday")+"</span>";
                   if (fSa)
                       return sString + _("on saturday")+"</span>";
                   if (fSo)
                       return sString + _("on sunday")+"</span>";
               }
               if (recObject.length == 0) {
                   return sString + _("no time defined")+"</span>";                
               }
                
               if (fMo)
                   sString += '<b>'+_('MO')+'</b> ,';
               else
                   sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('MO')+'</span> ,';
               if (fDi)
                   sString += '<b>'+_('TU')+'</b> ,';
               else
                   sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('TU')+'</span> ,';
               if (fMi)
                   sString += '<b>'+_('WE')+'</b> ,';
               else
                   sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('WE')+'</span> ,';
               if (fDo)
                   sString += '<b>'+_('TH')+'</b> ,';
               else
                   sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('TH')+'</span> ,';
               if (fFr)
                   sString += '<b>'+_('FR')+'</b> ,';
               else
                   sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('FR')+'</span> ,';
               if (fSa)
                   sString += '<b>'+_('SA')+'</b> ,';
               else
                   sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('SA')+'</span> ,';
               if (fSo)
                   sString += '<b>'+_('SU')+'</b>';
               else
                   sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('SU')+'</span>';
               return sString + "</span>";
               
               break;
        }
        return '';
    },
    setHeight : function(oHeight) {
        this.macPanel.setHeight(oHeight - 30);
        this.iDefaultHeight = oHeight - 57;
        for ( var oKey in this.grids)
            this.grids[oKey].setHeight(this.iDefaultHeight);
        this.callParent(arguments);
    },
    defMacGridRenderer : function(val, metadata, record, colIdx,nochNenParameter, store, view) {
        if (record.get('name') == '-') {
            return '<hr>';
        }
        var fHasIcon = false;
        if (record.get('icon') != null) {
            fHasIcon = true;
        }
        var fHasNext = false;
        if (record.get('next') == true) // definition erfordert weiterbutton
        {
            fHasNext = true;
        }
        if (record.get('group') != null) // ist eine gruppe -> weiterbutton
        {
            fHasNext = true;
        }
        if (record.get('dSID') != null) // ist ein device -> weiterbutton
        {
            fHasNext = true;
        }
        var fIsCheckable = false;
        if (record.get('checkable') != null)
            if (record.get('checkable')) {
                fHasNext = false; // checkboxen niemals weiterbuttons
                fHasIcon = false; // keine Icons nach Checkboxen
                fIsCheckable = true;
            }

        var fIsPassive = false;
        if (record.get('passive') != null)
            if (record.get('passive'))
                fIsPassive = true;

        if (record.get('id') == 0) {
        	if (view.up().parent.values.enabled!=null)
        		if ((view.up().parent.oActualValue==null) || (view.up().parent.oActualValue.type!='enabled'))
        			fIsPassive=true;
        }
        if (record.get('id') == 1) {
        	if (view.up().parent.values.weekdays!=null)
        		if ((view.up().parent.oActualValue==null) || (view.up().parent.oActualValue.type!='weekdays'))
        			fIsPassive=true;
        }
        if (record.get('id') == 2) {
        	if (view.up().parent.values.timeframe!=null) 
        		if ((view.up().parent.oActualValue==null) || (view.up().parent.oActualValue.type!='timeframe'))
        			fIsPassive=true;
        }
        if (record.get('id') == 4) {
            if (view.up().parent.values.zoneState!=null)
            	if ((view.up().parent.oActualValue==null) || (view.up().parent.oActualValue.type!='zoneState'))
            		fIsPassive=true;
        }
        if ((""+record.get('id')).indexOf('SystemState_')==0) {
            var sSystemID=record.get('id').substr(12);
            if (view.up().parent.values.systemState!=null) {
            	if ((view.up().parent.oActualValue==null) || (!((view.up().parent.oActualValue.type=='systemState') && (view.up().parent.oActualValue.name==sSystemID))))
            		for (var iIndex=0;iIndex<view.up().parent.values.systemState.length;iIndex++)	            	
		            	if (view.up().parent.values.systemState[iIndex].name==sSystemID)
		            			fIsPassive=true;
            }
        } 
        
        if (fIsPassive) {
            fHasNext = false; // spalte disabled -> niemals weiterbutton
            fIsChecked = false; // spalte disabled -> kann nicht gechecked sein
        }

        var sReturn = '<table style="height:16px;"><tr>';
        var iColspaceCounter = 3;
        if (fHasIcon) {
            iColspaceCounter--;
            sReturn += '<td><img src="' + record.get('icon') + '" style="margin-right: 5px;"></td>';
        }
        if (fIsCheckable) {
            iColspaceCounter--;
            if (record.get('checked') == true) {
                sReturn += '<td style="padding-right: 5px;"><div style="width:13px;height:13px;background-image:url('
                        + dss.staticDataModel.baseImagePath + 'dss/checkbox.gif); background-position: 0px -13px;" /></td>';
            } else {
                sReturn += '<td style="padding-right: 5px;"><div style="width:13px;height:13px;background-image:url('
                        + dss.staticDataModel.baseImagePath + 'dss/checkbox.gif);" /></td>';
            }
        }
        if (fHasNext)
            iColspaceCounter--;
        if (fIsPassive) {
            sReturn += '<td style="color:#888888;" colspan="' + iColspaceCounter + '" width="100%">' + record.get('name') + '</td>';
        } else {
            sReturn += '<td colspan="' + iColspaceCounter + '" width="100%">' + record.get('name') + '</td>';
        }
        if (fHasNext) {
            sReturn += '<td>&gt;</td>';
        }
        return sReturn + '</tr></table>';

    },
    initStores : function() {
        var me = this;
        this.gridStore = Ext.create('Ext.data.Store', {

            fields : [ 'pos', 'condition','subIndex' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            },
            listeners : {
                datachanged : function(store, eOpts) {
                    if (store.getCount() == 0)
                        me.lblSelectorAnzeige.setText(_('no condition'), false);
                    else if (store.getCount() == 1)
                        me.lblSelectorAnzeige.setText(_('1 condition'), false);
                    else
                        me.lblSelectorAnzeige.setText('' + store.getCount() + _(' conditions'), false);
                },
                clear : function(store, eOpts) {
                    me.lblSelectorAnzeige.setText(_('no condition'), false);
                }
            }
        });

        

        if (Ext.data.StoreManager.lookup('conditionConfigurator_systemStateStore') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'conditionConfigurator_systemStateStore',
                fields : [ 'value', 'name','valuerange' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            Ext.data.StoreManager.lookup('conditionConfigurator_systemStateStore').add(this.secondLevelStates);
        }
        
        if (Ext.data.StoreManager.lookup('conditionConfigurator_l1Store') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'conditionConfigurator_l1Store',
                fields : [ 'id', 'name', 'next', 'icon' ,'passive'],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
        }
        Ext.data.StoreManager.lookup('conditionConfigurator_l1Store').removeAll();
        var Aktionen = [];
        if (this.order!=null) {
        	
        	for (var iIndex=0;iIndex<this.order.length;iIndex++) {
        		var oObject=this.order[iIndex];
        		switch (oObject.type) {
	        		case 'enabler':
	    	            Aktionen.push({
	    	                name : _('Enabled'),
	    	                id : 0,
	    	                next : true,
	    	                icon : null,
	    	                passive:false
	    	            });
	        			break;
	        		case 'weekdays':
	    	            Aktionen.push({
	    	                name : _('Weekdays'),
	    	                id : 1,
	    	                next : true,
	    	                icon : null,
	    	                passive:false
	    	            });
	    	            break;
	        		case 'timeframe':
	    	            Aktionen.push({
	    	                name : _('Timeframe'),
	    	                id : 2,
	    	                next : true,
	    	                icon : null,
	    	                passive:false
	    	            });
	    	            break;
	        		case 'systemstate':
	    	            Aktionen.push({
	    	                name : _('SystemState'),
	    	                id : 3,
	    	                next : true,
	    	                icon : null,
	    	                passive:false
	    	            });
	    	            break;
	        		case 'zonestate':
	    	            Aktionen.push({
	    	                name : _('ZoneState'),
	    	                id : 4,
	    	                next : true,
	    	                icon : null,
	    	                passive:false
	    	            });
	    	            break;
	        		case 'state':
	    	            Aktionen.push({
	    	                name : _(this.order[iIndex].name),
	    	                id : 'SystemState_' + this.order[iIndex].name,
	    	                next : true,
	    	                icon : null,
	    	                passive:false
	    	            });
	    	            break;
	        		case '-':
	    	            Aktionen.push({
	    	                name : '-',
	    	                id : -1,
	    	                next : true,
	    	                icon : null,
	    	                passive:false
	    	            });
	    	            break;
	    	    }
        	}
        } else {
	        if (this.fFeatureEnabled.enabler) {
	            Aktionen.push({
	                name : _('Enabled'),
	                id : 0,
	                next : true,
	                icon : null,
	                passive:false
	            });
	        }
	        if (this.fFeatureEnabled.weekdays) {
	            Aktionen.push({
	                name : _('Weekdays'),
	                id : 1,
	                next : true,
	                icon : null,
	                passive:false
	            });
	        }
	        if (this.fFeatureEnabled.timeframe) {
	            Aktionen.push({
	                name : _('Timeframe'),
	                id : 2,
	                next : true,
	                icon : null,
	                passive:false
	            });
	        }
	        if (this.fFeatureEnabled.systemstate) {
	            Aktionen.push({
	                name : _('SystemState'),
	                id : 3,
	                next : true,
	                icon : null,
	                passive:false
	            });
	        }
	        if (this.fFeatureEnabled.zonestate) {
	            Aktionen.push({
	                name : _('ZoneState'),
	                id : 4,
	                next : true,
	                icon : null,
	                passive:false
	            });
	        }
	        for (var iIndex=0;iIndex<this.firstLevelStatesArray.length;iIndex++) {
	            Aktionen.push({
	                name : _(this.firstLevelStatesArray[iIndex].name),
	                id : 'SystemState_' + this.firstLevelStatesArray[iIndex].name,
	                next : true,
	                icon : null
	            });
	        }
        }
        Ext.data.StoreManager.lookup('conditionConfigurator_l1Store').add(Aktionen);
        if (Ext.data.StoreManager.lookup('conditionConfigurator_zoneStore') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'conditionConfigurator_zoneStore',
                fields : [ 'ZoneID', 'name' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            Ext.data.StoreManager.lookup('conditionConfigurator_zoneStore').add(dss.staticDataModel.getZoneArray());
        }
    },
    getGroupStore : function(ZoneID) {
        if (Ext.data.StoreManager.lookup('conditionConfigurator_groupStore_' + ZoneID) == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'conditionConfigurator_groupStore_' + ZoneID,
                fields : [ 'group', 'name', 'icon', 'reachable' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oGroup = dss.staticDataModel.getGroupForZone(ZoneID);
            Ext.data.StoreManager.lookup('conditionConfigurator_groupStore_' + ZoneID).add(oGroup);
        }
        return Ext.data.StoreManager.lookup('conditionConfigurator_groupStore_' + ZoneID);
    },
    getSceneStore : function(ZoneID, groupID) {
        if (Ext.data.StoreManager.lookup('conditionConfigurator_szeneStore_' + ZoneID + '_' + groupID) == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'conditionConfigurator_szeneStore_' + ZoneID + '_' + groupID,
                fields : [ 'id', 'name', 'reachable', 'icon', 'outputMode' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oScenes = dss.staticDataModel.getScenes(ZoneID, groupID);
            for ( var iIndex = 0; iIndex < oScenes.length; iIndex++) {
                var oObject = {};
                oObject.id = oScenes[iIndex].id;
                oObject.reachable = oScenes[iIndex].reachable;
                oObject.icon = oScenes[iIndex].icon;
                if (oScenes[iIndex].name == oScenes[iIndex].defaultName)
                    oObject.name = oScenes[iIndex].name;
                else
                    oObject.name = oScenes[iIndex].defaultName + ' - ' + oScenes[iIndex].name;
                Ext.data.StoreManager.lookup('conditionConfigurator_szeneStore_' + ZoneID + '_' + groupID).add(oObject);
            }

        }
        return Ext.data.StoreManager.lookup('conditionConfigurator_szeneStore_' + ZoneID + '_' + groupID);

    },
    constructEnabler : function() {
        var me=this;
        this.oActualValue={type:'enabler'};
        this.grids.lvlEnableCheckbox = Ext.create('Ext.form.RadioGroup', {
            fieldLabel : _('Enabled (choose one to set the condition)?'),
            items : [ {
                inputValue : false,
                boxLabel : _('disabled - that condition is allways disabled'),
                name : 'autoMode'
            }, {
                inputValue : true,
                boxLabel : _('enabled - that condition is enabled'),
                name : 'autoMode'
            } ],
            height : 60,
            width : 610,
            margin : "10 0 0 10",
            columns : 1,
            labelAlign : 'top',
            style : {
                color : "#005138"
            },
            listeners : {
                change : function (oThis,value) {
                    if (typeof(value.autoMode)=='boolean') {
                    	this.oActualValue={type:'enabler',value:value.autoMode};
                        //me.values.enabled=value.autoMode;
                        me.updateGridValues();
                    }
                } 
            }
        });

        this.grids.lvlEnable = Ext.create('Ext.panel.Panel', {
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            items : [ this.grids.lvlEnableCheckbox ]
        });

        this.grids.lvlEnable.parent = this;
        this.grids.lvlEnableCheckbox.parent = this;
        this.macPanel.add(this.grids.lvlEnable);
        if (this.values.enabled!=null)
            this.grids.lvlEnableCheckbox.setValue({autoMode:this.values.enabled});
            
    },
    constructWeekdays : function() {
        var me=this;
        this.oActualValue={type:'weekdays'};
        this.grids.lvlWeekdaySelector = Ext.create('DSS.component.WeekdaySelection', {
            name : 'lvlWeekdaySelector',
            label : _('Only active on'),
            fOnlyWeekdays:true,
            listeners: {
                change:function (value) {
                	me.oActualValue={type:'weekdays',value:value.timeArray};
                    me.updateGridValues();
                }
            }
        });        
        this.grids.lvlWeekday = Ext.create('Ext.panel.Panel', {
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            items : [this.grids.lvlWeekdaySelector]
        });

        this.grids.lvlWeekday.parent = this;
        this.macPanel.add(this.grids.lvlWeekday);
        if (this.values.weekdays!=null)
            this.grids.lvlWeekdaySelector.setValue({recurrenceBase:'weekly',timeArray:this.values.weekdays});
    },
    constructTimeframe : function() {
        var me=this;
        this.oActualValue={type:'timeframe'};
        this.grids.lvlTimeFrameMin = Ext.create('DSS.component.TimeReference', {
            name : 'lvlTimeFrameMin',
            label : _('Timeframe starts at'),
            fAlternativeDisplay:true,
            fFeatureEnabled:{
                fStaticEnabled:true,
                fDuskEnabled:false,
                fDawnEnabled:false,
                fSunsetEnabled:false,
                fSunriseEnabled:false
            }            
        // referenceChangeListener:subConfig.referenceChangeListener
        });
        this.grids.lvlTimeFrameMax = Ext.create('DSS.component.TimeReference', {
            name : 'lvlTimeFrameMax',
            label : _('Timeframe ends at'),
            fAlternativeDisplay:true,
            fFeatureEnabled:{
                fStaticEnabled:true,
                fDuskEnabled:false,
                fDawnEnabled:false,
                fSunsetEnabled:false,
                fSunriseEnabled:false
            }
        });

        this.grids.lvlTimeframe = Ext.create('Ext.panel.Panel', {
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            items : [ this.grids.lvlTimeFrameMin, this.grids.lvlTimeFrameMax ]
        });
        
        this.grids.lvlTimeframe.parent = this;
        this.macPanel.add(this.grids.lvlTimeframe);
        
        this.grids.lvlTimeFrameMin.reset();
        this.grids.lvlTimeFrameMax.reset();
        
        if (this.values.timeframe!=null)
            if (this.values.timeframe.length>0) {
                this.grids.lvlTimeFrameMin.setValue(this.values.timeframe[0].start);
                this.grids.lvlTimeFrameMax.setValue(this.values.timeframe[0].end);
            }
        
        var fnChange=function (value) {
            me.oActualValue={type:'timeframe',value:{start:me.grids.lvlTimeFrameMin.getValue(),end:me.grids.lvlTimeFrameMax.getValue()}};
            me.updateGridValues();
        }
        
        this.grids.lvlTimeFrameMin.on('change',fnChange);
        this.grids.lvlTimeFrameMax.on('change',fnChange);
        
    },
    constructSystemState : function() {
    	this.oActualValue={type:'systemstate'};
        var oSystemStateControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'value', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oSystemStateStore = Ext.data.StoreManager.lookup('conditionConfigurator_systemStateStore');
        oSystemStateStore.each(function(record) {
            var oNewRecord = record.copy()
            oSystemStateControlStore.add(oNewRecord);
        });
        oSystemStateControlStore.sort('name');

        this.grids.lvlSystemState = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oSystemStateControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('State'),
                dataIndex : 'name',
                flex : 1,
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table><tr><td width="100%">' + _(record.get('name')) + '</td><td>&gt;</td></tr></table>';
                }
            } ]
        });

        this.grids.lvlSystemState.parent = this;
        this.grids.lvlSystemState.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlSystemStateValue);
            var stateID = record.get('name');
            this.parent.constructSystemStateValueGrid(stateID);
            
        });
        this.macPanel.add(this.grids.lvlSystemState);
    },
    constructSystemStateValueGrid:function (stateName) {
        var me = this;
        this.oActualValue={type:'systemState',name:stateID};
        var oSystemStateValueControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'value', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var oSystemStateStore = Ext.data.StoreManager.lookup('conditionConfigurator_systemStateStore');
        var oRecord=oSystemStateStore.findRecord('name', stateName,0,false,false,true);
        oSystemStateValueControlStore.add(oRecord.get('valuerange'));

        oSystemStateValueControlStore.sort('name');

        this.grids.lvlSystemStateValue = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 474,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oSystemStateValueControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('State value'),
                dataIndex : 'name',
                flex : 1,
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table><tr><td width="100%">' + _(stateName+'_'+record.get('name')) + '</td></tr></table>';
                }
            } ]
        });

        this.grids.lvlSystemStateValue.parent = this;
        this.grids.lvlSystemStateValue.on('itemclick', function(grid, record) {
            var sName=record.get('name');
            var sBaseState=stateName;
            
            me.oActualValue={type:'systemState',name:stateID,value:sName};
            me.updateGridValues();
        });
        this.grids.lvlSystemStateValue.on('itemdblclick', function(grid, record) {
        	this.parent.addSubItem();
        	this.parent.updateGridValues();
        	this.parent.macPanel.collapse(Ext.Component.DIRECTION_BOTTOM, true);
        });
        this.macPanel.add(this.grids.lvlSystemStateValue);
    },
    constructLVL2SystemState : function (stateName) {
        var me = this;
        this.oActualValue={type:'systemState',name:stateName};
        var oSystemStateValueControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'value', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var oSystemState = null;
        for (var iIndex=0;iIndex<this.firstLevelStatesArray.length;iIndex++) {
            if (this.firstLevelStatesArray[iIndex].name==stateName) {
                oSystemStateValueControlStore.add(this.firstLevelStatesArray[iIndex].valuerange);
            }
        }

        oSystemStateValueControlStore.sort('name');

        this.grids.lvlSystemStateValue = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oSystemStateValueControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('State value'),
                dataIndex : 'name',
                flex : 1,
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table><tr><td width="100%">' + _(stateName+'_'+record.get('name')) + '</td></tr></table>';
                }
            } ]
        });

        this.grids.lvlSystemStateValue.parent = this;
        this.grids.lvlSystemStateValue.on('itemclick', function(grid, record) {
            var sName=record.get('value');
            var sBaseState=stateName;
            me.oActualValue={type:'systemState',name:sBaseState,value:sName};
            me.updateGridValues();
            me.updatePanelDescription();
        });
        this.grids.lvlSystemStateValue.on('itemdblclick', function(grid, record) {
        	this.parent.addSubItem();
        	this.parent.updateGridValues();
        	this.parent.macPanel.collapse(Ext.Component.DIRECTION_BOTTOM, true);
        });
        this.macPanel.add(this.grids.lvlSystemStateValue);
    },
    constructZoneStateLvlGroup : function(zoneID) {
        var me=this;
        this.oActualValue={type:'zoneState',zone:zoneID};
        var oGroupControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'id', 'group', 'name', 'icon', 'reachable' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oGroupStore = this.getGroupStore(zoneID);
        oGroupStore.each(function(record) {
            var oNewRecord = record.copy()
            if (oNewRecord.get('reachable')) {
                if (oNewRecord.get('group') != 0) {
                    if (oNewRecord.get('group') != 8) {
                        oGroupControlStore.add(oNewRecord);
                    }
                }
            }
        });
        oGroupControlStore.add({
            group : -1,
            name : '-',
            passive:'-',
            icon : null,
            reachable : true
        });
        var oSceneGroup0Store;
        if (zoneID == 0)
            oSceneGroup0Store = this.getSceneStore(dss.staticDataModel.getZoneArray()[1].ZoneID, 0);
        else
            oSceneGroup0Store = this.getSceneStore(zoneID, 0);
        oSceneGroup0Store.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('reachable'))
                oGroupControlStore.add(oNewRecord);
        });

        this.grids.lvlGroup = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oGroupControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('activity'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        
        this.grids.lvlGroup.on('itemdblclick', function(grid, record) {
        	this.parent.addSubItem();
        	this.parent.updateGridValues();
            this.parent.macPanel.collapse(Ext.Component.DIRECTION_BOTTOM, true);
        });
        this.grids.lvlGroup.on('itemclick', function(grid, record) {
            if (record.get('group') == -1) {
                grid.getSelectionModel().deselect(record);
                return;
            }

            this.parent.macPanel.remove(this.parent.grids.lvlScene);
            var zoneID = this.parent.grids.lvlRoom.getSelectionModel().getSelection()[0].get('ZoneID');
            var groupID = record.get('group');
            this.parent.oActualValue={type:'zoneState',zone:zoneID,group:groupID};
            if ((zoneID != null) && (groupID != null)) {
                this.parent.constructZoneStateLvlGroupScene(zoneID, groupID);
                this.getSelectionModel().deselectAll();
                this.getSelectionModel().select(record);
            }
            if (groupID == null) {
                grid.store.each(function(record) {
                    if (record.get('group') != null)
                        grid.getSelectionModel().deselect(record);
                });
            }
            var zoneID = this.parent.grids.lvlRoom.getSelectionModel().getSelection()[0].get('ZoneID');          
            if (record.get('id') >= 0) {                       
                me.oActualValue={type:'zoneState',value:{zone:zoneID,group:0,scene:record.get('id')}};                
            } else {
            	 me.oActualValue={type:'zoneState',value:{zone:zoneID,group:groupID}};
            }
            me.updateGridValues();
        });

        this.grids.lvlGroup.parent = this;
        this.macPanel.add(this.grids.lvlGroup);
    },
    constructZoneStateLvlGroupScene : function(zoneID, groupID, fAll, fForce) {
        var me=this;
        this.oActualValue={type:'zoneState',zone:zoneID,group:groupID};
        var oSceneControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'id', 'name', 'icon', 'reachable', 'checkable', 'checked' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        if (fAll == null)
            fAll = false;
        if (fForce == null)
            fForce = false
        if (zoneID==-1)
            zoneID=0;
        var oSceneStore = this.getSceneStore(zoneID, groupID);
        oSceneControlStore.add({
            id : -3,
            name : _('show all scenes'),
            icon : null,
            reachable : true,
            checkable : true,
            checked : fAll

        });
        oSceneControlStore.add({
            id : -1,
            name : '-',
            passive:true,
            icon : null,
            reachable : true
        });
        oSceneStore.each(function(record) {
            var oNewRecord = record.copy()
            if (oNewRecord.get('reachable') || fAll)
                    if (oNewRecord.get('id') < 64)
                    oSceneControlStore.add(oNewRecord);
        });

        this.grids.lvlScene = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 324,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oSceneControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('scene'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids.lvlScene.parent = this;

        this.grids.lvlScene.on('itemdblclick', function(grid, record) {
        	me.addSubItem();
        	me.updateGridValues();
            me.macPanel.collapse(Ext.Component.DIRECTION_BOTTOM, true);
        });
        
        this.grids.lvlScene.on('itemclick', function(grid, record) {
            if (record.get('id') == -1) {
                this.getSelectionModel().deselect(record);
                return;
            }

            if (record.get('checkable') != null) {
                if (record.get('checkable')) {
                    this.getSelectionModel().deselect(record);
                    var fChecked = !record.get('checked');
                    record.set('checked', fChecked);
                    grid.getSelectionModel().deselectAll();
                    if (record.get('id') == -3) {
                        // alle Stimmungen
                        grid.store.removeAll();

                        grid.store.add({
                            id : -3,
                            name : _('show all scenes'),
                            icon : null,
                            reachable : true,
                            checkable : true,
                            checked : record.get('checked')

                        });
                        grid.store.add({
                            id : -1,
                            name : '-',
                            passive:true,
                            icon : null,
                            reachable : true
                        });
                        oSceneStore.each(function(record) {
                            var oNewRecord = record.copy();
                            if (oNewRecord.get('reachable') || fChecked)
                                if (oNewRecord.get('id') < 64)
                                    grid.store.add(oNewRecord);
                        });

                    }
                }
                return;
            }
            if (record.get('id') >= 0) { 
                var zoneID = this.parent.grids.lvlRoom.getSelectionModel().getSelection()[0].get('ZoneID');
                var groupID = this.parent.grids.lvlGroup.getSelectionModel().getSelection()[0].get('group');
                if (zoneID != null) {
                    if (groupID != null) {
                        me.oActualValue={type:'zoneState',value:{zone:zoneID,group:groupID,scene:record.get('id')}};
                    }
                }
                me.oActualValue={type:'zoneState',value:{zone:zoneID,group:groupID,scene:record.get('id')}};
                me.updateGridValues();
            }   

        });
        this.macPanel.add(this.grids.lvlScene);
    },
    constructZoneState : function() {
    	this.oActualValue={type:'zoneState'};
        var oZoneControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'ZoneID', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oZoneStore = Ext.data.StoreManager.lookup('conditionConfigurator_zoneStore');
        oZoneStore.each(function(record) {
            var oNewRecord = record.copy()
            if (oNewRecord.get('ZoneID') != 0)
                oZoneControlStore.add(oNewRecord);
        });
        oZoneControlStore.sort('name');

        this.grids.lvlRoom = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oZoneControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('room'),
                dataIndex : 'name',
                flex : 1,
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table><tr><td width="100%">' + record.get('name') + '</td><td>&gt;</td></tr></table>';
                }
            } ]
        });

        this.grids.lvlRoom.parent = this;
        this.grids.lvlRoom.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlGroup);
            this.parent.macPanel.remove(this.parent.grids.lvlScene);
            var zoneID = record.get('ZoneID');
            if (zoneID == -1)
                zoneID = 0;
            this.parent.constructZoneStateLvlGroup(zoneID);
            this.parent.oActualValue={type:'zoneState',value:{zone:zoneID}};
            this.parent.updateGridValues();
        });
        this.macPanel.add(this.grids.lvlRoom);
    },
    constructMacGrids : function() {
    	this.oActualValue=null;
        var lvl1TempStore = Ext.create('Ext.data.Store', {
            fields : [ 'id', 'name', 'next', 'icon' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var lvl1Store = Ext.data.StoreManager.lookup('conditionConfigurator_l1Store');
        lvl1Store.each(function(record) {
            var oNewRecord = record.copy();
            lvl1TempStore.add(oNewRecord);
        });

        this.grids.lvl1 = Ext.create('Ext.grid.Panel', {
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            hideHeaders : true,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : lvl1Store,
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvl1.getSelectionModel().store = this.grids.lvl1.store;
        this.grids.lvl1.parent = this;

        this.grids.lvl1.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlEnable);
            this.parent.macPanel.remove(this.parent.grids.lvlWeekday);
            this.parent.macPanel.remove(this.parent.grids.lvlTimeframe);
            this.parent.macPanel.remove(this.parent.grids.lvlSystemState);
            this.parent.macPanel.remove(this.parent.grids.lvlRoom);
            this.parent.macPanel.remove(this.parent.grids.lvlGroup);
            this.parent.macPanel.remove(this.parent.grids.lvlScene);
            this.parent.macPanel.remove(this.parent.grids.lvlSystemStateValue);
            this.parent.oActualValue = null;
            var fIsPassive = false;
            if (record.get('passive') != null) {
                if (record.get('passive') == true) {
                    this.getSelectionModel().deselect(record);
                    fIsPassive = true;
                }
            }

            if (!fIsPassive) {
                if (record.get('id') == 0) {
                    this.parent.constructEnabler();
                }
                if (record.get('id') == 1) {
                    this.parent.constructWeekdays();
                }
                if (record.get('id') == 2) {
                    this.parent.constructTimeframe();
                }
                if (record.get('id') == 3) {
                    this.parent.constructSystemState();
                }
                if (record.get('id') == 4) {
                    this.parent.constructZoneState();
                }
                if ((""+record.get('id')).indexOf('SystemState_')==0) {
                    var sSystemID=record.get('id').substr(12);
                    this.parent.constructLVL2SystemState(sSystemID);
                }
            }
            this.parent.macPanel.doLayout();
            this.parent.updatePanelDescription();
        });
       this.macPanel.add(this.grids.lvl1);
    },
    addSubItem : function () {
    	if (this.oActualValue==null)
    		return false;
    	
    	if (this.fEditMode) {
            var oSelectedRecord=this.getSelectedMainRecord();
            switch(oSelectedRecord.get('condition')) {
                case 'enabler':
                    this.values.enabled=null;
                    break;
                case 'weekdays':
                	this.values.weekdays=null;
                    break;
                case 'timeframe':
                    var iSubIndex=oSelectedRecord.get('subIndex');
                    this.values.timeframe=null;
                    break;
                case 'zonestate':
                    var iSubIndex=oSelectedRecord.get('subIndex');
                    this.values.zoneState.splice(iSubIndex,1);
                    break;
                case 'systemstate':
                    var iSubIndex=oSelectedRecord.get('subIndex');
                    this.values.systemState.splice(iSubIndex,1);
                    break;
            }
    	}
    	this.fEditMode=false;

    	switch (this.oActualValue.type) {
    		case 'enabler': {
    			if (this.oActualValue.value==null)
    				return false;
    			this.values.enabled=this.oActualValue.value;
    			this.oActualValue=null;
    			this.updateGridValues();
	    		return true;
    		}
    		case 'weekdays': {
    			if (this.oActualValue.value==null)
    				return false;
    			this.values.weekdays=this.oActualValue.value;
    			this.oActualValue=null;
    			this.updateGridValues();
	    		return true;
    		}
	    	case 'timeframe' : {
    			if (this.oActualValue.value==null)
    				return false;
	    		this.values.timeframe=[{start:this.oActualValue.value.start,end:this.oActualValue.value.end}];
    			this.oActualValue=null;
    			this.updateGridValues();
    			return true;
	    	}
	    	case 'systemState' : {
    			if (this.oActualValue.name==null)
    				return false;
    			if (this.oActualValue.value==null)
    				return false;
	    		var fFound=false;
	    		if (this.values.systemState==null)
	    			this.values.systemState=[];
	    		for (var iIndex=0;iIndex<this.values.systemState.length;iIndex++) {
	    			if (this.values.systemState[iIndex].name==this.oActualValue.name) {
	    				this.values.systemState[iIndex].value=this.oActualValue.value;
	    				fFound=true;
	    			}
	    		}
	    		if (!fFound) {
	    			this.values.systemState.push({name:this.oActualValue.name,value:this.oActualValue.value});
	    		}
    			this.oActualValue=null;
    			this.updateGridValues();
	    		return true;
	    	}
	    	case 'zoneState' : {
    			if (this.oActualValue.value==null)
    				return false;
    			if (this.oActualValue.value.zone===null)
    				return false;
    			if (this.oActualValue.value.group===null)
    				return false;
    			if (this.oActualValue.value.scene===null)
    				return false;
	    		
	    		if (this.values.zoneState==null)
	    			this.values.zoneState=[];
	    		this.values.zoneState.push({zone:this.oActualValue.value.zone,group:this.oActualValue.value.group,scene:this.oActualValue.value.scene});
    			this.oActualValue=null;
    			this.updateGridValues();
	    		return true;
	    	}
	    }
    	return false;
    },
    setSelectedSubItem : function(oObject) {
        this.oActualValue = oObject;
        if (this.getSelectedMainRecord() == null) {
            var oNewRecord = this.gridStore.add({
                pos : 0,
                condition : oObject
            });
            this.setSelectedMainRecord(this.gridStore.getCount() - 1);
        } else {
            this.getSelectedMainRecord().set('condition', oObject);
            this.getSelectedMainRecord().commit();
        }
        this.removeCls('myInvalid');
        this.updatePanelDescription();
    },
    setSelectedMainRecord : function(index) {
        this.mainGrid.getSelectionModel().select(index);
        var selectedRec=this.getSelectedMainRecord();
        this.setMacGrid(selectedRec.get('condition'),selectedRec.get('subIndex'));
    },
    getSelectedMainRecord : function() {
        if (this.mainGrid.getSelectionModel().getSelection() == null)
            return null;
        return this.mainGrid.getSelectionModel().getSelection()[0];
    },
    deselectMainGrid : function() {
        var oldSelect = this.getSelectedMainRecord();
        if (oldSelect != null) {
            this.mainGrid.getSelectionModel().deselect(oldSelect);
        } else
            this.mainGrid.getSelectionModel().deselectAll();
    },
    setMacGrid : function(oObject,index) {
    	this.macPanel.remove(this.grids.lvl1);
        this.macPanel.remove(this.grids.lvlEnable);
        this.macPanel.remove(this.grids.lvlWeekday);
        this.macPanel.remove(this.grids.lvlTimeframe);
        this.macPanel.remove(this.grids.lvlSystemState);
        this.macPanel.remove(this.grids.lvlRoom);
        this.macPanel.remove(this.grids.lvlGroup);
        this.macPanel.remove(this.grids.lvlScene);
        this.macPanel.remove(this.grids.lvlSystemStateValue);


        switch (oObject) {
            case 'timeframe':
                this.oActualValue = {type:oObject,value:{start:this.values.timeframe[0].start,end:this.values.timeframe[0].end}};
                this.constructMacGrids();
                
            	this.fEditMode=true;
                var oRecordLVL1 = this.grids.lvl1.store.find('id', 2,0,false,false,true);
                if (oRecordLVL1 != -1)
                    this.grids.lvl1.getSelectionModel().select(oRecordLVL1);
                this.constructTimeframe();
                break;
            case 'zonestate':
            	this.fEditMode=true;
                var oZoneObject=this.values.zoneState[parseInt(index)];                
                
            	
                this.oActualValue = {type:oObject,value:{zone:oZoneObject.zone,group:oZoneObject.group,scene:oZoneObject.scene}};
                this.constructMacGrids();
                var oRecordLVL1 = this.grids.lvl1.store.find('id', 4,0,false,false,true);
                if (oRecordLVL1 != -1)
                    this.grids.lvl1.getSelectionModel().select(oRecordLVL1);
                
                
                this.constructZoneState();
                var oRecordZone = this.grids.lvlRoom.store.find('ZoneID', oZoneObject.zone,0,false,false,true);
                if (oRecordZone != -1)
                    this.grids.lvlRoom.getSelectionModel().select(oRecordZone);
                else
                    break;

                this.constructZoneStateLvlGroup(oZoneObject.zone)
                if (oZoneObject.group == 0) {
                    var oRecordGroup = this.grids.lvlGroup.store.find('id', oZoneObject.scene,0,false,false,true);
                    if (oRecordGroup != -1)
                        this.grids.lvlGroup.getSelectionModel().select(oRecordGroup);
                    else 
                        break;
                } else {
                    var oRecordGroup = this.grids.lvlGroup.store.find('group', oZoneObject.group,0,false,false,true);
                    if (oRecordGroup != -1)
                        this.grids.lvlGroup.getSelectionModel().select(oRecordGroup);
                    else
                        break;
                    this.constructZoneStateLvlGroupScene(oZoneObject.zone, oZoneObject.group, false, false);

                    var oRecordScene = this.grids.lvlScene.store.find('id', oZoneObject.scene,0,false,false,true);
                    if (oRecordScene != -1) {
                        this.grids.lvlScene.getSelectionModel().select(oRecordScene);
                    } else {
                        this.macPanel.remove(this.grids.lvlScene);
                        this.constructZoneStateLvlGroupScene(oZoneObject.zone, oZoneObject.group, true, false);
                        var oRecordScene = this.grids.lvlScene.store.find('id', -1 * oZoneObject.scene,0,false,false,true);
                        if (oRecordScene != -1) {
                               this.grids.lvlScene.getSelectionModel().select(oRecordScene);
                        }
                        else 
                            break;
                    }
                    if (oRecordScene > 11) {
                        var me = this;
                        var fn = function() {
                            me.grids.lvlScene.setScrollTop((oRecordScene) * 21);
                        };
                        window.setTimeout(fn, 10);
                    }   
                }
                break;
            case 'systemstate':
            	this.fEditMode=true;
            	var oState=this.values.systemState[index];
                this.oActualValue = {type:'systemState',name:oState.name,value:oState.value};
                this.constructMacGrids();
                
                var fFirstLevel=false;
                for (var iIndex=0;iIndex<this.firstLevelStatesArray.length;iIndex++) {
                    if (oState.name==this.firstLevelStatesArray[iIndex].name) {
                        fFirstLevel=true;
                    } 
                }
                if (!fFirstLevel) {
                    var oRecordLVL1 = this.grids.lvl1.store.find('id', 3,0,false,false,true);
                    if (oRecordLVL1 != -1) {
                        this.grids.lvl1.getSelectionModel().select(oRecordLVL1);
                        this.constructSystemState();
                        var oRecordLVL2 = this.grids.lvlSystemState.store.find('name', oState.name,0,false,false,true);
                        if (oRecordLVL2 != -1) {
                            this.grids.lvlSystemState.getSelectionModel().select(oRecordLVL2);
                            this.constructSystemStateValueGrid(oState.name);
                            var oRecordLVL3=this.grids.lvlSystemStateValue.store.find('value', oState.value,0,false,false,true)
                            if (oRecordLVL3!=-1)
                                this.grids.lvlSystemStateValue.getSelectionModel().select(oRecordLVL3);
                        }                        
                    }
                } else {
                    var oRecordLVL1 = this.grids.lvl1.store.find('id', 'SystemState_'+oState.name,0,false,false,true);
                    if (oRecordLVL1 != -1) {
                        this.grids.lvl1.getSelectionModel().select(oRecordLVL1);
                        this.constructLVL2SystemState(oState.name);
                        var oRecordLVL2=this.grids.lvlSystemStateValue.store.find('value', oState.value,0,false,false,true)
                        if (oRecordLVL2!=-1)
                            this.grids.lvlSystemStateValue.getSelectionModel().select(oRecordLVL2);
                    }
                }
                this.oActualValue = {type:'systemState',name:oState.name,value:oState.value};
                break;
            case 'enabler':
            	this.fEditMode=true;
            	 this.oActualValue = {type:oObject};
                 this.constructMacGrids();
            	var oRecordLVL1 = this.grids.lvl1.store.find('id', 0,0,false,false,true);
                if (oRecordLVL1 != -1)
                    this.grids.lvl1.getSelectionModel().select(oRecordLVL1);
                this.constructEnabler();
                break;
            case 'weekdays':
            	this.fEditMode=true;
            	 this.oActualValue = {type:oObject};
                 this.constructMacGrids();
            	var oRecordLVL1 = this.grids.lvl1.store.find('id', 1,0,false,false,true);
                if (oRecordLVL1 != -1)
                    this.grids.lvl1.getSelectionModel().select(oRecordLVL1);
                this.constructWeekdays();
                break;
           default:
        	   this.constructMacGrids();
        	   break;        	   
        }
        this.macPanel.doLayout();
        this.updatePanelDescription();
    },
    eventHandlerSelectionChange : function(view, selections, options) {
        var mThis = this;
        if (this.parent != null)
            mThis = this.parent;
        if (selections.length > 0) {
            mThis.oButtonEdit.setDisabled(false);
            mThis.oButtonDelete.setDisabled(false);
            var selIndex = -1;
            for ( var iIndex = 0; iIndex < view.store.getCount(); iIndex++) {
                if (view.store.getAt(iIndex) == selections[0])
                    selIndex = iIndex;
            }
            mThis.oButtonUp.setDisabled(selIndex == 0);
            mThis.oButtonDown.setDisabled(selIndex == (view.store.getCount() - 1));
            var iIndex = mThis.mainGrid.store.indexOf(selections[0]);
            mThis.lblSelectorAnzeige.setText(Ext.String.format2(_('condition {index}/{count}'), {
                index : '' + (iIndex + 1),
                count : '' + view.store.getCount()
            }), false);        
        } else {
            mThis.oButtonEdit.setDisabled(true);
            mThis.oButtonDelete.setDisabled(true);
            mThis.oButtonUp.setDisabled(true);
            mThis.oButtonDown.setDisabled(true);
            if (view.store.getCount() == 0)
                mThis.lblSelectorAnzeige.setText(_('no condition'), false);
            else if (view.store.getCount() == 1)
                mThis.lblSelectorAnzeige.setText(_('1 condition'), false);
            else
                mThis.lblSelectorAnzeige.setText('' + view.store.getCount() + _(' conditions'), false);
        }
        if ( mThis.macPanel.collapsed) {
        	//mThis.oActualValue = mThis.getSelectedMainRecord();
        }
    },
    constructor : function(config) {
        Ext.tip.QuickTipManager.init();

        var mThis = this;
    	this.fEditMode=false;

        this.fFeatureEnabled = {
            enabler : false,
            weekdays : false,
            timeframe : false,
            systemstate : false,
            zonestate : false
        };
        if (config.order!=null) {
        	this.order=[];
        	for (var iIndex=0;iIndex<config.order.length;iIndex++) {
        		switch(config.order[iIndex].type) {
        			case 'enabler': 
        				this.fFeatureEnabled.enabler=true;
        				this.order.push({type:config.order[iIndex].type});
                	break;
        			case 'weekdays': 
        				this.order.push({type:config.order[iIndex].type});
        				this.fFeatureEnabled.weekdays=true;
        			break;
        			case 'timeframe': 
        				this.order.push({type:config.order[iIndex].type});
        				this.fFeatureEnabled.timeframe=true;
        			break;        				
        			case 'systemstate': 
        				this.order.push({type:config.order[iIndex].type});
        				this.fFeatureEnabled.systemstate=true;
        			break;      
        			case 'zonestate': 
        				this.order.push({type:config.order[iIndex].type});
        				this.fFeatureEnabled.zonestate=true;
        			break;   
        			case '-': 
        				this.order.push({type:'-'});
        			break;   
        			case 'state':
        				this.order.push({type:config.order[iIndex].type,name:config.order[iIndex].name});
        		        var oArray=dss.staticDataModel.getStates();
        		        for (var jIndex=0;jIndex<oArray.length;jIndex++) {            
        		            var oState=oArray[jIndex];        		            
		                    if (oState.name==config.order[iIndex].name) {
	        		            if (oState.name=='daynight') {
	        		            	oState.valuerange=[{name:'day',value:'daynight_true'},
	        		            	                   {name:'night',value:'daynight_false'},
	        		            	                   {name:'bright',value:'twilight_true'},
	        		            	                   {name:'dark',value:'twilight_false'}]
	        		            }		                    	
		                        this.firstLevelStatesArray.push(oState);
		                    }
        		        }        
        			break;
        		}
        		
        	}
        } else {
	        if (config.fFeatureEnabled.enabler != null)
	            if (config.fFeatureEnabled.enabler)
	                this.fFeatureEnabled.enabler = config.fFeatureEnabled.enabler;
	        if (config.fFeatureEnabled.weekdays != null)
	            if (config.fFeatureEnabled.weekdays)
	                this.fFeatureEnabled.weekdays = config.fFeatureEnabled.weekdays;
	        if (config.fFeatureEnabled.timeframe != null)
	            if (config.fFeatureEnabled.timeframe)
	                this.fFeatureEnabled.timeframe = config.fFeatureEnabled.timeframe;
	        if (config.fFeatureEnabled.systemstate != null)
	            if (config.fFeatureEnabled.systemstate)
	                this.fFeatureEnabled.systemstate = config.fFeatureEnabled.systemstate;
	        if (config.fFeatureEnabled.zonestate != null)
	            if (config.fFeatureEnabled.zonestate)
	                this.fFeatureEnabled.zonestate = config.fFeatureEnabled.zonestate;
	        
	        var oArray=dss.staticDataModel.getStates();
	        for (var iIndex=0;iIndex<oArray.length;iIndex++) {            
	            var oState=oArray[iIndex];
	            if (config.firstLevelStates!=null) {
	                for (var jIndex=0;jIndex<config.firstLevelStates.length;jIndex++) {                    
	                    if (oState.name==config.firstLevelStates[jIndex]) {
	                        this.firstLevelStatesArray.push(oState);
	                    }
	                } 
	            }
	        }
        }

        for (var iIndex=0;iIndex<oArray.length;iIndex++) {            
            var fSecond=true;
            var oState=oArray[iIndex];
            if (config.firstLevelStates!=null) {
                for (var jIndex=0;jIndex<this.firstLevelStatesArray.length;jIndex++) {                    
                    if (oState.name==this.firstLevelStatesArray[jIndex].name) {                      
                        fSecond=false;
                    }
                } 
            }
            if (fSecond)
                this.secondLevelStates.push(oState);
            
        }
        this.initStores();
        
        this.lblSelectorAnzeige = Ext.create('Ext.form.Label', {
            width : 200,
            height : 22,
            padding : 4,
            style : {
                textAlign : 'right',
            }
        });

        this.oButtonNew = Ext.create('Ext.button.Button', {
            iconCls : 'icon-add-action',
            text : _('new condition'),
            handler : function() {
            	this.parent.addSubItem();
                this.parent.oActualValue = null;
                this.parent.macPanel.expand(true);

                this.parent.setMacGrid();
                this.parent.deselectMainGrid();
            }
        });
        this.oButtonNew.parent = this;

        this.oButtonEdit = Ext.create('Ext.button.Button', {
            iconCls : 'icon-edit-action',
            text : _('edit condition'),
            disabled : true,
            handler : function() {
                if (this.parent.macPanel.collapsed) {
                    this.parent.macPanel.expand(true);
                    this.parent.oActualValue = this.parent.getSelectedMainRecord();
                    this.parent.setMacGrid(this.parent.oActualValue.get('condition'),this.parent.oActualValue.get('subIndex'));
                } else {
                	this.parent.addSubItem();                	
                    this.parent.macPanel.collapse(Ext.Component.DIRECTION_BOTTOM, true);
                }
            }
        });
        this.oButtonEdit.parent = this;

        this.oButtonUp = Ext.create('Ext.button.Button', {
            iconCls : 'icon-left-action',
            disabled : true,
            handler : function() {
                var iIndex = this.parent.mainGrid.store.indexOf(this.parent.getSelectedMainRecord());
                mThis.setSelectedMainRecord(iIndex - 1);
            }
        });
        this.oButtonUp.parent = this;

        this.oButtonDown = Ext.create('Ext.button.Button', {
            iconCls : 'icon-right-action',
            disabled : true,
            handler : function() {
                var iIndex = this.parent.mainGrid.store.indexOf(this.parent.getSelectedMainRecord());
                mThis.setSelectedMainRecord(iIndex + 1);
            }
        });
        this.oButtonDown.parent = this;

        this.oButtonDelete = Ext.create('Ext.button.Button', {
            iconCls : 'icon-delete-action',
            tooltip : _('delete condition'),
            disabled : true,
            handler : function() {
                this.parent.macPanel.collapse(Ext.Component.DIRECTION_BOTTOM, true);
                var oSelectedRecord=this.parent.getSelectedMainRecord();
                switch(oSelectedRecord.get('condition')) {
                    case 'enabler':
                        mThis.values.enabled=null;
                        break;
                    case 'weekdays':
                        mThis.values.weekdays=null;
                        break;
                    case 'timeframe':
                        var iSubIndex=oSelectedRecord.get('subIndex');
                        mThis.values.timeframe=null;
                        break;
                    case 'zonestate':
                        var iSubIndex=oSelectedRecord.get('subIndex');
                        mThis.values.zoneState.splice(iSubIndex,1);
                        break;
                    case 'systemstate':
                        var iSubIndex=oSelectedRecord.get('subIndex');
                        mThis.values.systemState.splice(iSubIndex,1);
                        break;
                }
                mThis.updateGridValues();
            }
        });
        this.oButtonDelete.parent = this;

        this.mainGrid = Ext.create('Ext.grid.Panel', {
            enableColumnHide : false,
            enableColumnMove : false,
            selType : 'rowmodel',
            border : '0',
            region : 'center',
            height : "100%",
            store : this.gridStore,
            hideHeaders : true,
            autoScroll : false,
            columns : [ {
                header : _('condition'),
                dataIndex : 'condition',
                sortable : false,
                hideable : false,
                flex : 1,
                renderer : this.defMainGridRenderer
            } ],
            tbar : [ this.oButtonNew, this.oButtonEdit,
            // { xtype: 'button', text: 'Erweiterte Ansicht',
            // id: 'action-selector-btn-extended' ,
            // disabled:true},
            '->', this.lblSelectorAnzeige, this.oButtonUp, this.oButtonDown, this.oButtonDelete ]
        });
        this.mainGrid.parent = this;
        this.mainGrid.on({
            selectionchange : this.eventHandlerSelectionChange,
            itemdblclick : function(grid, record, item, index, e) {
                this.parent.macPanel.expand(true);
                this.parent.setMacGrid((this.parent.getSelectedMainRecord()).get('condition'),this.parent.getSelectedMainRecord().get('subIndex'));
            }
        });

        this.macPanel = Ext.create('Ext.panel.Panel', {
            border : '0',
            region : 'south',
            title : _('show condition editor'),
            collapsible : true,
            collapsed : false,
            collapseMode : 'header',
            autoScroll : true,
            height : 320,
            layout : {
                type : 'hbox'
            },
            listeners : {
                collapse : function(pPanel) {
                    pPanel.up().macPanel.setTitle('');
                    pPanel.up().oButtonEdit.setDisabled(pPanel.up().getSelectedMainRecord() == null);
                    pPanel.up().oButtonEdit.setText(_('edit condition'));
                    pPanel.up().mainGrid.doLayout();
                },
                expand : function(pPanel) {
                    pPanel.up().updatePanelDescription();
                    pPanel.up().oButtonEdit.setDisabled(false);
                    pPanel.up().oButtonEdit.setText(_('show all conditions'));
                    pPanel.up().mainGrid.doLayout();
                }
            },
            scroll : 'horizontal'

        });

        Ext.apply(this, {
            items : [ this.mainGrid, this.macPanel ]
        });

        this.callParent(arguments);
    },
    reset : function() {
        this.setValue(null);
    },
    setValue : function(values) {
        var me = this;
        if (values==null)
        	values= {
                enabled: null, // singular value
                weekdays: null, // singularvalue
                timeframe: null, // array ....
                zoneState:null,
                systemState:null
            };
        this.values=values;
        if (this.values.systemState!=null) {
	        for (var iIndex=0;iIndex<this.firstLevelStatesArray.length;iIndex++) {
	        	if (this.firstLevelStatesArray[iIndex].name=='daynight') {
	        		for (var kIndex=0;kIndex<this.values.systemState.length;kIndex++) {
	        			if (this.values.systemState[kIndex].name=='daynight') 
	        				if (this.values.systemState[kIndex].value==true)
	        					this.values.systemState[kIndex].value='daynight_true';
	        			if (this.values.systemState[kIndex].name=='daynight') 
	        				if (this.values.systemState[kIndex].value==false)
	        					this.values.systemState[kIndex].value='daynight_false';
	        			if (this.values.systemState[kIndex].name=='twilight') 
	        				if (this.values.systemState[kIndex].value==true) {
	        					this.values.systemState[kIndex].name='daynight';
	        					this.values.systemState[kIndex].value='twilight_true';
	        				}
	        			if (this.values.systemState[kIndex].name=='twilight') 
	        				if (this.values.systemState[kIndex].value==false) {
	        					this.values.systemState[kIndex].name='daynight';
	        					this.values.systemState[kIndex].value='twilight_false';
	        				}
	        		}
	        	}
	        }
        }
        this.updateGridValues();
        this.removeCls('myInvalid');
        if ((values == null)|| (this.gridStore.getCount()==0)) {
            this.gridStore.removeAll();
            this.doLayout();
            this.macPanel.expand(false);
            this.lblSelectorAnzeige.setText(_('no condition'), false);
            this.setMacGrid();
        } else {
            if (this.gridStore.getCount() == 1) {
                this.macPanel.expand(false);
                this.setSelectedMainRecord(0);           
                this.setMacGrid(this.getSelectedMainRecord().get('condition'),this.getSelectedMainRecord().get('subIndex'));
            } else
                this.macPanel.collapse(Ext.Component.DIRECTION_BOTTOM, false);
        }

    },
    isValid : function() {
        return true;
    },
    getValue : function() {
    	this.addSubItem();
        var localValues= {
            enabled: null, // singular value
            weekdays: null, // singularvalue
            timeframe: null, // array ....
            zoneState:null,
            systemState:null
        };
        if (this.values.enabled !== null)
        	localValues.enabled=this.values.enabled;
        if (this.values.weekdays !== null)
        	localValues.weekdays=this.values.weekdays;
        if (this.values.timeframe !== null)
        	localValues.timeframe=this.values.timeframe;
        if (this.values.zoneState !== null)
        	localValues.zoneState=this.values.zoneState;
        if (this.values.systemState !== null) {
        	localValues.systemState=[];
        	for (var iIndex=0;iIndex<this.values.systemState.length;iIndex++) {
        		if (this.values.systemState[iIndex].name=='daynight') {
        			if (this.values.systemState[iIndex].value=='daynight_true') {
        				localValues.systemState.push({name:'daynight',value:true});
        			} else 
        				if (this.values.systemState[iIndex].value=='daynight_false') {
        					localValues.systemState.push({name:'daynight',value:false});
            			} else 
            				if (this.values.systemState[iIndex].value=='twilight_true') {
            					localValues.systemState.push({name:'twilight',value:true});
                			} else 
                				if (this.values.systemState[iIndex].value=='twilight_false') {
                					localValues.systemState.push({name:'twilight',value:false});
                    			} else 
                    				localValues.systemState.push({name:this.values.systemState[iIndex].name,value:this.values.systemState[iIndex].value});
        		} else
        			localValues.systemState.push({name:this.values.systemState[iIndex].name,value:this.values.systemState[iIndex].value});
        	}	
        }
        return localValues;
    }
 });
